
var targetImage;
var overlayText;
var targetContainer;


///////////////////////////////////////////////////////////////////
// The Init function is called when bric is first selected       //
// Use it to make changes to the initial state of the sidebar UI //
///////////////////////////////////////////////////////////////////

function init(bricVersion)
{
	targetImage = $('.hover-tilt-img-item');
	overlayText = $('.hover-tilt-label');
	targetContainer = $('.img-hover-tilt-container');
	
	var imgPath = targetImage.attr('src');
	var imgPathX2 = '';
	var imgPathX3 = '';
	
	if(targetImage.hasAttr('src-2')) // Has @2x Image Set
	{
		imgPathX2 = targetImage.attr('src-2');
	}
	
	if(targetImage.hasAttr('src-3')) // Has @3x Image Set
	{
		imgPathX3 = targetImage.attr('src-3');
	}
	
	// Set Image thumbnail
	window.webkit.messageHandlers.setUIVal.postMessage('{"attr":"bric-image-data","value":"'+imgPath+'","sync":"false","imageRes":"1","image2x":"'+imgPathX2+'","image3x":"'+imgPathX3+'"}'); 
}

//////////////////////
// Custom Functions //
//////////////////////

// Apply New Image Value
function setImage(imgPath,imgRes)
{	
	if(imgRes == 1) // @1x
	{
		targetImage.attr('src',imgPath);
	}
	else // @2x & @3x
	{
		setHighResImg(imgPath,imgRes);
	}
	
	window.webkit.messageHandlers.sync.postMessage("changes"); // Sync Changes
	window.webkit.messageHandlers.sync.postMessage("changes"); // sync Changes
}

// Set High Res image
function setHighResImg(imgPath,imgRes)
{	
	// Dont store actual paths to assets for multi res as they 
	// are not used within Blocs, srcset paths should be set 
	// up for use on export ie. img/myimage.png and 
	// full paths stored to src-2 & src-3 helper attributes which are used 
	// within design enviroment.
	
	var fileName = getFileExportName(imgPath); // Get Image File Name	
	var srcSetData = targetImage.attr('srcset-blocsapp'); // Retina SRC Data
	var newData = fileName+' '+imgRes+'x';
	
	if(imgRes == 2) // @2x
	{
		if(targetImage.hasAttr('src-3')) // Has @3x Value
		{
			newData += ', '+getFileExportName(targetImage.attr('src-3'))+' 3x';
		}
	}
	else // @3x
	{
		if(targetImage.hasAttr('src-2')) // Has @3x Value
		{
			newData = getFileExportName(targetImage.attr('src-2'))+' 2x, '+ newData;
		}
	}
	
	targetImage.attr('srcset-blocsapp',newData).attr("src-"+imgRes, imgPath); // Set Image
	
	// src-2, src-3 are helper attributes which are used to store the paths 
	// in the design enviroment, these attributes are removed when project is exported. 
}

// Get Image File Export Name
function getFileExportName(imgPath)
{	
	var fileName = 'img/'+imgPath.split('/').pop();
	
	if(imgPath.substring(0,4) == 'http')
	{
		fileName = imgPath;
	}
	
	return fileName;
}

// Set Overlay Text Value
function setOverlayText(V)
{
	overlayText.text(V);
	window.webkit.messageHandlers.sync.postMessage("changes"); // sync Changes
}

// Set Image Alt Value
function setAltValue(V)
{
	targetImage.attr('alt',V);
	window.webkit.messageHandlers.sync.postMessage("changes"); // sync Changes
}

// Set Image Width
function setImgWidth(V)
{
	applyImgDimention(V,'width');
}

// Set Image Height
function setImgHeight(V)
{	
	applyImgDimention(V,'height');
}

// Apply Image Dimention - (Value | Attribute)
function applyImgDimention(V,A)
{
	if (parseInt(V) > 0) // Has value so remove responsive class
	{	
		targetImage.removeClass('img-responsive').attr(A,V);
	}
	else // Value is empty reset to responsive
	{
		targetImage.addClass('img-responsive').attr(A,V);
	}
	
	window.webkit.messageHandlers.sync.postMessage("changes"); // sync Changes
}

// Set Type Face
function setTypeFace(typeFace)
{
	if (typeFace.indexOf(":")!= -1 ) // Font has a weight
	{
		var breakIndx = typeFace.indexOf(":");
		overlayText.css("font-family",typeFace.substring(0,breakIndx));
		overlayText.css("font-weight",typeFace.substring(breakIndx+1));
	}
	else // Simple Font
	{
		overlayText.css("font-family",typeFace);
	}
	
	window.webkit.messageHandlers.sync.postMessage("changes"); // Sync Changes
}

// Set Overlay Text Colour
function setTextColor(V)
{
	overlayText.toggleClass('hover-tilt-light-text');	
	window.webkit.messageHandlers.sync.postMessage("changes"); // sync Changes
}

// Set Overlay Text Colour
function toggleSheen(attrValue,attrName)
{
	targetContainer.removeAttr('data-tilt-glare data-tilt-maxglare');

	if(attrValue == 1) // Add Sheen
	{
		targetContainer.attr('data-tilt-glare','true').attr('data-tilt-maxglar','.5');
	}

	window.webkit.messageHandlers.sync.postMessage("changes"); // sync Changes
}



/////////////
// Plugins //
/////////////


// Has Attribute
$.fn.hasAttr = function(name){  
   return this.attr(name) !== undefined;
};